;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MPTtoVT pattern CONVERTER V0.6 Beta ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Original done in QBasic by ANDROID 2011
;; AutoIT script by KGMcNeil Mar 28th 2012
;;
;; This script presupposes that you have 
;; Opened ModPlugTracker, and Copied the
;; pattern into the clipboard via:
;;
;; "Select ALL" then "COPY" from the menu.
;; 
;; It then converts the clipboard content
;; into a pattern that can be pasted into
;; a typical VortexTracker text module...
;;
;; For now, it only does one pattern at a
;; time, but that is because ModPlug can
;; only copy the contents of one pattern
;; at a time... 
;;
;; Enjoy!!!!
;;


Local $header,$marker,$IN,$Offset,$len,$Chan1,$Chan2,$Chan3,$newline,$OUT,$line,$Notes,$part,$Tmp

$newline = chr(13) & chr(10)
$marker = "|"
$IN = ClipGet()
$Offset=StringInStr($IN, $newline,0,1)+1
$header=StringLeft($IN,$Offset)
$len=StringInStr ( $IN, $newline, 0,2) - $Offset +1

$Notes = 0
$OUT = ""
$line = "1"
$part = 0
$Tmp = ""

DO
$line = StringMid($IN, $Offset, $len)

If StringInStr ( $line, $header) Then	;; Skip Headers, if multiple patterns fed to it
	$Offset = $Offset + StringLen($header)
	$line = StringMid($IN, $Offset, $len)
	EndIf

$Chan1 = StringMid($line, 1+StringInStr($line,$marker,0,1), 3)
$Chan1 = StringReplace($Chan1, "...", "---")
$Chan1 = StringReplace($Chan1, "===", "R--")

$Chan2 = StringMid($line, 1+StringInStr($line,$marker,0,2), 3)
$Chan2 = StringReplace($Chan2, "...", "---")
$Chan2 = StringReplace($Chan2, "===", "R--")

$Chan3 = StringMid($line, 1+StringInStr($line,$marker,0,3), 3)
$Chan3 = StringReplace($Chan3, "...", "---")
$Chan3 = StringReplace($Chan3, "===", "R--")

$Tmp = "....|..|" & $Chan1 & " .... ....|" & $Chan2 & " .... ....|" & $Chan3 & " .... ...."
   
If $Notes = 64 Then ;; This breaks down large midi tracks into 64 row patterns
   $part = $part +1
   $Tmp = $newline & "[Pattern" & $part & "]" & $newline & $Tmp
   $Notes = 0
   EndIf
   
If StringLen ( $line ) = $len Then
	$OUT=$OUT & $Tmp & $newline
	$Notes = $Notes +1
    Else
    $Tmp = ""
    EndIf

$Offset = $Offset + $len
	
Until $Tmp = ""

ClipPut ($OUT)
Beep (500,200)
Exit

